summaryrefslogtreecommitdiff
path: root/helpers/lh_chroot_dpkg
diff options
context:
space:
mode:
Diffstat (limited to 'helpers/lh_chroot_dpkg')
-rwxr-xr-xhelpers/lh_chroot_dpkg88
1 files changed, 88 insertions, 0 deletions
diff --git a/helpers/lh_chroot_dpkg b/helpers/lh_chroot_dpkg
new file mode 100755
index 0000000..ae08f8a
--- /dev/null
+++ b/helpers/lh_chroot_dpkg
@@ -0,0 +1,88 @@
+#!/bin/sh
+
+# lh_chroot_dpkg(1) - manage /sbin/dpkg
+# Copyright (C) 2006-2007 Daniel Baumann <daniel@debian.org>
+#
+# live-helper comes with ABSOLUTELY NO WARRANTY; for details see COPYING.
+# This is free software, and you are welcome to redistribute it
+# under certain conditions; see COPYING for details.
+
+set -e
+
+# Including common functions
+LH_BASE="${LH_BASE:-/usr/share/live-helper}"
+
+for FUNCTION in "${LH_BASE}"/functions/*.sh
+do
+ . "${FUNCTION}"
+done
+
+# Setting static variables
+DESCRIPTION="manage /sbin/dpkg"
+HELP=""
+USAGE="${PROGRAM} {install|remove} [--force]"
+
+Arguments "${@}"
+
+# Reading configuration files
+Read_conffile config/common
+Read_conffile config/bootstrap
+Read_conffile config/chroot
+Read_conffile config/binary
+Read_conffile config/source
+Read_conffile "${LH_CONFIG}"
+Set_defaults
+
+# Requiring stage file
+Require_stagefile .stage/bootstrap
+
+case "${1}" in
+ install)
+ Echo_message "Configuring file /sbin/start-stop-daemon"
+
+ # Checking stage file
+ Check_stagefile .stage/chroot_dpkg
+
+ # Checking lock file
+ Check_lockfile .lock
+
+ # Creating lock file
+ Create_lockfile .lock
+
+ # Save start-stop-daemon program
+ mv chroot/sbin/start-stop-daemon chroot/sbin/start-stop-daemon.orig
+
+ # Create start-stop-daemon program
+
+cat > chroot/sbin/start-stop-daemon << EOF
+#!/bin/sh
+
+exit 0
+EOF
+
+ chmod 755 chroot/sbin/start-stop-daemon
+
+ # Creating stage file
+ Create_stagefile .stage/chroot_dpkg
+ ;;
+
+ remove)
+ # Checking lock file
+ Check_lockfile .lock
+
+ # Creating lock file
+ Create_lockfile .lock
+
+ Echo_message "Deconfiguring file /sbin/start-stop-daemon"
+
+ # Restore start-stop-daemon program
+ mv chroot/sbin/start-stop-daemon.orig chroot/sbin/start-stop-daemon
+
+ # Removing stage file
+ rm -f .stage/chroot_dpkg
+ ;;
+
+ *)
+ Usage
+ ;;
+esac